#ifndef GAME_H_
#define GAME_H_

enum {
	KEY_ESC = 27,
	KEY_DEL = 127,

	KEY_F1 = 256,
	KEY_F2,
	KEY_F3,
	KEY_F4,
	KEY_F5,
	KEY_F6,
	KEY_F7,
	KEY_F8,
	KEY_F9,
	KEY_F10,
	KEY_F11,
	KEY_F12,
	KEY_LEFT,
	KEY_RIGHT,
	KEY_UP,
	KEY_DOWN,
	KEY_HOME,
	KEY_END,
	KEY_PGUP,
	KEY_PGDOWN,
	KEY_INSERT
};

enum {
	MODKEY_SHIFT	= 1,
	MODKEY_CTRL		= 2,
	MODKEY_ALT		= 4
};


extern int win_width, win_height;
extern float win_aspect;
extern long frame_time;
extern float frame_dt;

bool game_init();
void game_cleanup();

void game_draw();
void game_reshape(int x, int y);

void game_keyboard(int key, bool pressed);
void game_mbutton(int bn, bool pressed, int x, int y);
void game_mmotion(int x, int y);
void game_mwheel(int dir, int x, int y);

// defined in main.cc
void game_quit();
bool game_keystate(int key);
bool game_bnstate(int bn);

unsigned int game_modkeys();

#endif	/* GAME_H_ */
